<?php

namespace WPEasyTranslate\Service;

use WPEasyTranslate\Plugin;

class Language
{
    public static function all(){
        $settings = Plugin::settings();
        $path = Plugin::path('assets/languages.json');
        $languages = json_decode(file_get_contents($path), true);

        $languages['en']['flag'] = $settings->english_flag;

        return $languages;
    }

    public static function selected(){
        $all = self::all();
        $settings = Plugin::settings();
        $languages = [];
        foreach($all as $key => $value) {
            if($settings->$key){
                $languages[$key] = $value;
            }
        }

        return $languages;
    }

    public static function as_array($languages, $sort){
        $temp = [];
        foreach($languages as $key => $value) {
            $temp[] = array_merge($value, ['code' => $key]);
        }
        $languages = $temp;

        return $languages;
    }

    public static function site_language(){
        try {
            $locale = get_locale();
            return explode('_', $locale)[0];
        }catch(\Exception $e){
            return 'en';
        }
    }

    public static function selected_as_array(){
        return self::as_array(self::selected(), null);
    }
}