<?php


namespace MetatickPluginLib\Cache;


class Cache
{
    protected $slug = null;
    protected $expiration = 60;

    public function __construct($slug, $expiration = 60)
    {
        $this->slug = $slug;
        $this->expiration = $expiration;
    }

    public function get_expiration($expiration)
    {
        if (is_null($expiration)) {
            return $this->expiration;
        }
        return $expiration;
    }

    public function child($slug, $expiration = null)
    {
        $expiration = $this->get_expiration($expiration);
        return new Cache("$this->slug.$slug", $expiration);
    }

    public function get($key)
    {
        return get_transient("$this->slug:$key");
    }

    public function set($key, $value, $expiration = null)
    {
        $expiration = $this->get_expiration($expiration);
        return set_transient("$this->slug:$key", $value, $expiration);
    }

    public function delete($key)
    {
        return delete_transient("$this->slug:$key");
    }

    public function get_or_set($key, $callback, $expiration = null)
    {
        $value = $this->get($key);
        if($value === false){
            $value = $callback();
            $this->set($key, $value, $expiration);
        }
        return $value;
    }
}